; Noise estimation of the observations
pro noise

; Intensity
	restore,'/net/dedal/scratch/aasensio/HINODE/SUNSPOT_SCANNING/20070227_115110/stI.idl'
	restore,'/net/dedal/scratch/aasensio/HINODE/SUNSPOT_SCANNING/20070227_115110/stQ.idl'
	restore,'/net/dedal/scratch/aasensio/HINODE/SUNSPOT_SCANNING/20070227_115110/stU.idl'
	restore,'/net/dedal/scratch/aasensio/HINODE/SUNSPOT_SCANNING/20070227_115110/stV.idl'

	lambda = findgen(112)
; Normalize to the continuum
	for i = 0, 63 do begin
		for j = 0, 511 do begin
			x = [lambda[0:5],lambda[100:105]]
			y = [reform(sti[i,0:5,j]),reform(sti[i,100:105,j])]		
			res = linfit(x,y)
			cont = poly(lambda, res)
 			sti[i,*,j] = sti[i,*,j] / cont
 			stq[i,*,j] = stq[i,*,j] / cont
 			stu[i,*,j] = stu[i,*,j] / cont
 			stv[i,*,j] = stv[i,*,j] / cont
		endfor
	endfor	

; Quiet Sun
	sigma_I = stddev(sti[*,0:10,400:500])
	sigma_Q = stddev(stq[*,0:10,400:500])
	sigma_U = stddev(stu[*,0:10,400:500])
	sigma_V = stddev(stv[*,0:10,400:500])

	print, 'sigmaI = ', sigma_I
	print, 'sigmaQ = ', sigma_Q
	print, 'sigmaU = ', sigma_U
	print, 'sigmaV = ', sigma_V

; Local continuum
	st = total(total(sti[*,*,400:500],3),1) / (64.*101.)
	x = [lambda[0:5],lambda[100:109]]
	y = [reform(st[0:5]),reform(st[100:109])]
	res = linfit(x,y)
	cont = poly(lambda, res)
	save,cont,filename='local_quiet_continuum.idl'

	stop
	
end