; Calculate the chi^2 in the weak-field case
; and estimate the evidence from the integral of the chi^2
pro weakf
	B = findgen(10000) / 9999.d0 * 2000.d0 - 1000.d0

	dat = ddread('../OBSERVATIONS/test_imax.prof',offset=2,/count)

	didl = reform(deriv(dat[0,*],dat[1,*]))
	V = reform(dat[4,*])
	sigma = dat[8,0]
	
	chi2 = fltarr(10000)
	alpha = -4.67d-13 * 3.d0 * 5250.2d0^2
	for i = 0, 9999 do begin
		chi2[i] = total( (V - alpha * B[i] * didl)^2 / sigma^2)
	endfor

	L = exp(-0.5d0 * chi2)

	p1 = 0.5d0 * alpha^2 * total(didl^2) / sigma^2
	p2 = -alpha * total(v*didl) / sigma^2
	p3 = 0.5d0 * total(v^2) / sigma^2

	print, 'ln Z= ', 0.5d0 * alog(!DPI) - 0.5d0 * alog(p1) + p2^2/(4.d0*p1) - p3
	print, 'ln Z= ', alog(tsum(B, L))

	cwpal
	
	plot, B, L
	oplot, B, exp(-(p1*B^2+p2*B+p3)), col=2

	ind = where(L eq max(L))
	Bmax = B[ind[0]]

	stop
	plot, V
	oplot, alpha * Bmax * didl, col=2
	stop
end