! Uses Gaussian quadrature for angular integrations
!
Subroutine AngQuad(NLTE,NLTEInput)
  Use Gauss_quad
  Use NLTE_inp
  Use NLTE_vars
  Implicit None
  Type (NLTE_variables) :: NLTE
  Type (NLTE_input) :: NLTEInput
!
  If (NLTEInput%NMU .gt. 5) then
     Print *,'Too many angles in angular quadrature:',NLTEInput%NMU
     Print *,'This version supports only up to NMU=5'
     Print *,'Should be easy to modify forward/gauss_quad.f90 and'
     Print *,'forward/NLTE/angquad.f90 to support more'
     Stop 
  End if
  NLTE%XMu(1:NLTEInput%NMU)=XMU_Gauss_Quad(NLTEInput%NMU,1:NLTEInput%NMU)
  NLTE%WMu(1:NLTEInput%NMU)=WMU_Gauss_Quad(NLTEInput%NMU,1:NLTEInput%NMU)
!
End Subroutine AngQuad
