! Compute Voigt profiles Phi and integrated profile WPhi for each transition
! Store the resulting Phi in virtual file PHI and WPhi in the NLTE structure
!
Subroutine VoigtProfs(NLTE, NLTEInput, Atom)
  Use Param_structure
  Use NLTE_Atom_structure
  Use NLTE_inp
  Use NLTE_vars
  Use VirtualFiles
  Use Line_data_structure
  Implicit None
  Type (NLTE_Atom) :: Atom
  Type (NLTE_variables) :: NLTE
  Type (NLTE_input) :: NLTEInput
  Type (Line_data) :: Line
  Real, Dimension (NLTE%NDEP) :: Phi
  Real :: WQMU, xlam, DlDop, DlDopcms, DlDopkms, Damp, H, F, voigt
  Integer :: itran, imu, inu, idepth, nwave
!
  Call RewindVirtualFile('PHI')
  NLTE%WPhi(:,:)=0.
!
  Do itran=1, Atom%NLIN
     Line%Wlength=Atom%Alamb(itran)
     Line%ion_stage=Atom%ion(Atom%i(itran))
     Line%Atomic_number=Atom%Z
     Line%Energy_low=Atom%eV(Atom%i(itran))
     Line%VDW_enh=Atom%GW(itran)
     Do inu=1, Atom%NQ(itran)
        Do imu=1, NLTEInput%NMU
           WQMU=Atom%WQ(inu, itran)*NLTE%WMu(imu)
           Do idepth=1, NLTE%NDEP
              DlDop=Atom%Alamb(itran)/cc* &
                   Sqrt(2.*bk*NLTE%Atmo%Temp(idepth)/Atom%AWgt/mass_pr+ &
                   NLTE%Atmo%v_mic(idepth)**2.)  ! Angstroms
              DlDopcms=DlDop/Atom%Alamb(itran)*cc ! DlDop in cm/s
              DlDopkms=DlDopcms*1e-5 ! DlDop in km/s
              If (.not. NLTEInput%VelFree .or. imu .eq. 1) then
                 Call Damping(Line, NLTE%Atmo%Temp(idepth), &
                      NLTE%Atmo%El_p(idepth), NLTE%Atmo%Gas_P(idepth), &
                      DlDop, Damp, Atom%GA(itran), Atom%GQ(itran))
                 xlam=Atom%Q(inu,itran)*NLTEInput%QNORM/DlDopkms
                 xlam=xlam-NLTE%XMu(imu)*NLTE%Atmo%v_los(idepth)/&
                      DlDopcms ! Wlength in Doppler units (dimensionless)
                 H=voigt(Damp, xlam, 0)
                 Phi(idepth)=H/(DlDopkms/NLTEInput%QNORM*SqrtPi)
              End if
              NLTE%WPhi(idepth,itran)=NLTE%WPhi(idepth,itran)+ &
                   WQMU*Phi(idepth)
           End do ! End idepth do
           If (.not. NLTEInput%VelFree .or. imu .eq. 1) &
                Call WriteP(PHI)
        End do ! End imu do
     End do ! End inu do
  End do ! End itran do
!
  NLTE%Wphi=1./NLTE%Wphi(:,:)
!
  Call RewindVirtualFile('PHI')
  Return
!
End Subroutine VoigtProfs
