Function Saha(npoints, T, Ne, U1, U2, E_ioniz)
!
! The Saha equation. This function returns the ratio of the atoms in the
! ionization stage 1 to those in the next ionization stage (e.g., neutrals
! over ions)
!
  Use Param_structure
  Use Atomic_data
  Implicit none
  Real, dimension (npoints) :: T, Ne, U1, U2, Saha
  Real*8, dimension (npoints) :: Sahad
  Real :: E_ioniz
  Integer :: npoints
!
  Sahad(1:npoints)=Ne(1:npoints)*2.07D-16*U1(1:npoints)/U2(1:npoints)* &
       (T(1:npoints)**(-1.5))*exp(E_ioniz/bk/T(1:npoints)*1.d0)
  Where(Sahad .gt. 1.e38) 
     Sahad=1.e38
  End Where
  Saha=Sahad
  Return
End Function Saha
