!
Subroutine BackgroundOpac(NLTE, NLTEInput, Atom)
  Use Param_structure
  Use Atomic_data
  Use NLTE_Atom_structure
  Use NLTE_inp
  Use NLTE_vars
  Use Model_structure
  Use VirtualFiles
  Use Background_opacity_module, Only: Background_opacity
  Implicit None
  Type (NLTE_variables) :: NLTE
  Type (NLTE_input) :: NLTEInput
  Type (NLTE_Atom) :: Atom
  Real, Dimension (NLTE%NDEP) :: XCONT, SC, SCAT
  Real :: Freq, P_el, T_el, Theta, P_g, Planck, n2P, ScatCoef
  Integer :: ihtot, idepth, itran, inu, i0
!
! Calculate standard opacities at 500nm (will be used for normalization)
!
     Do idepth=1, NLTE%NDEP
        n2P=BK*NLTE%Atmo%Temp(idepth)
        NLTE%Xnorm(idepth)=Background_opacity(NLTE%Atmo%Temp(idepth), NLTE%Atmo%El_p(idepth), NLTE%Atmo%nH(idepth)*n2P, &
             NLTE%Atmo%nHminus(idepth)*n2P, NLTE%Atmo%nHplus(idepth)*n2P, NLTE%Atmo%nH2(idepth)*n2P, 0., 5000.,ScatCoef)
     End do
!
! Calculate background opacities at central wavelength of each line transition
!
     Call RewindVirtualFile('OPC')
     Do itran=1, Atom%NLIN
        freq=2.99792458e18/Atom%Alamb(itran)
        Do idepth=1, NLTE%NDEP
           n2P=BK*NLTE%Atmo%Temp(idepth)
           XCONT(idepth)=Background_opacity(NLTE%Atmo%Temp(idepth), NLTE%Atmo%El_p(idepth), NLTE%Atmo%nH(idepth)*n2P, &
                NLTE%Atmo%nHminus(idepth)*n2P, NLTE%Atmo%nHplus(idepth)*n2P, NLTE%Atmo%nH2(idepth)*n2P, 0., Atom%Alamb(itran),ScatCoef)/ &
                NLTE%XNorm(idepth)
              NLTE%BPlanck(idepth,itran)=Planck(freq,NLTE%Atmo%Temp(idepth))
           SC(idepth)=XCONT(idepth)/(XCONT(idepth)+ScatCoef)* &
                NLTE%BPlanck(idepth,itran)
           SCAT(idepth)=ScatCoef/(XCONT(idepth)+ScatCoef)
        End do
        Call WriteX(XCONT, SCAT, SC)
     End do
!
! Calculate background opacities at each wavelength of continuum transitions
!
     Do itran=Atom%NLIN+1, Atom%NLIN+Atom%NCNT
        Do inu=1, Atom%NQ(itran)
           freq=Atom%FRQ(inu, itran)
           Do idepth=1, NLTE%NDEP
              n2P=BK*NLTE%Atmo%Temp(idepth)
              XCONT(idepth)=Background_opacity(NLTE%Atmo%Temp(idepth), NLTE%Atmo%El_p(idepth), NLTE%Atmo%nH(idepth)*n2P, &
                   NLTE%Atmo%nHminus(idepth)*n2P, NLTE%Atmo%nHplus(idepth)*n2P, NLTE%Atmo%nH2(idepth)*n2P, 0., Atom%FRQ(inu, itran),ScatCoef)/ &
                   NLTE%XNorm(idepth)
              NLTE%BPlanck(idepth,itran)=Planck(freq,NLTE%Atmo%Temp(idepth))
              SC(idepth)=XCONT(idepth)/(XCONT(idepth)+ScatCoef)* &
                   NLTE%BPlanck(idepth,itran)
              SCAT(idepth)=ScatCoef/(XCONT(idepth)+ScatCoef)
           End do
           Call WriteX(XCONT, SCAT, SC)
        End do
     End do
!
      Return
!
End Subroutine BackgroundOpac


