! Use a Neural network to obtain Pe from (T,Pg)
!
Subroutine Pe_From_T_Pg(T, Pg, Pe)
  Real :: T, Pe, Pg
  Integer :: ANNunit
  Integer, Save :: nlayers, ninputs, noutputs, nmaxperlayer
  Integer, Dimension(:), Allocatable, Save :: Nonlin
  Integer, Dimension(:), Allocatable, Save :: nperlayer
  Real, Dimension(:,:,:), Allocatable, Save :: W, y
  Real, Dimension(:,:), Allocatable, Save :: Beta
  Real, Dimension(:), Allocatable, Save :: xnorm, xmean, ynorm, ymean, &
       inputs, outputs
  Real :: LogPe, LogPg
  Logical, Save:: First_time=.TRUE.
!
  If (First_time) then ! Load and initialize ANN
     Call Open_file_unform(ANNunit,'Pe_from_T_Pg.net')
     Read (ANNunit) nlayers, nmaxperlayer, ninputs, noutputs
     Allocate (Nonlin(1:nlayers))
     Allocate (nperlayer(0:nlayers))
     Allocate (W(1:nlayers, 1:nmaxperlayer, 1:nmaxperlayer))
     Allocate (y(0:nlayers, 1:nmaxperlayer, 1:nmaxperlayer))
     Allocate (Beta(1:nlayers, 1:nmaxperlayer))
     Allocate (xnorm(1:ninputs))
     Allocate (xmean(1:ninputs))
     Allocate (ynorm(1:noutputs))
     Allocate (ymean(1:noutputs))
     Allocate (inputs(ninputs))
     Allocate (outputs(noutputs))
     Read (ANNunit) Nonlin(1:nlayers), nperlayer(0:nlayers)
     Read (ANNunit) W(1:nlayers, 1:nmaxperlayer, 1:nmaxperlayer)
     Read (ANNunit) Beta(1:nlayers, 1:nmaxperlayer)
     Read (ANNunit) xnorm(1:ninputs), xmean(1:ninputs)
     Read (ANNunit) ynorm(1:noutputs), ymean(1:noutputs)
     Close (ANNunit)     
  End if
  First_time=.FALSE.

  LogPg=Log10(Pg)
  inputs(1)=(T-xmean(1))/xnorm(1)
  inputs(2)=(LogPg-xmean(2))/xnorm(2)

  Call ANN_Forward(W, Beta, Nonlin, inputs, outputs, nlayers, &
       nmaxperlayer, nperlayer, ninputs, noutputs, y)

  LogPe=outputs(1)*ynorm(1)+ymean(1)
  Pe=10.**(LogPe)

End Subroutine Pe_From_T_Pg
