! This routine extracts the Orbital Angular Momentum (L) from the
! letter codification
!
Subroutine Extract_OAM(Design, OAM)
Implicit NONE
Character :: Design
Character, Dimension (13) :: CODE
Character, Dimension (21) :: CODE1
Real :: OAM
Integer :: i
Data CODE/'S','P','D','F','G','H','I','K','L','M','N',   &
     'O','Q'/
Data code1/'p','1','f','2','h','3','k','4','m','5','o', &
     '6','r','7','t','8','u','9','v','0','w'/

OAM=-1.
Do i=1, 13
   If (Design .eq. CODE(i)) OAM=i-1.
End do

If (abs(OAM+1) .lt. 1.e-3) then
   Do i=1, 21
      If (Design .eq. CODE1(i)) OAM=float(i)/2.
   End do
End if

If (abs(OAM+1) .lt. 1.e-3) then
   Print *,'The letter used to code the Orbital Angular Momentum (',Design,')'
   Print *,'could not be recognized. STOP in extract_oam'
   Stop
End if

Return

End Subroutine Extract_OAM
