	subroutine tqli(d,e,n,np,z)
!
!  Adapted to double precision from the Numerical Recipes
!
	integer n,np
	integer i,iter,k,l,m

	double precision d(np),e(np),z(np,np)
	double precision b,c,dd,f,g,p,r,s,dpythag

	do i=2,n
	  e(i-1)=e(i)
	end do
	e(n)=.0d0
	do l=1,n
	  iter=0
1       do m=l,n-1
	    dd=dabs(d(m))+dabs(d(m+1))
	    if ((dabs(e(m))+dd).eq.dd) goto 2
	  end do
	  m=n
2       if (m.ne.l)then
	    if (iter.eq.30) pause 'too many iterations in tqli'
	    iter=iter+1
	    g=(d(l+1)-d(l))/(.2d1*e(l))
	    r=dpythag(g,.1d1)
	    g=d(m)-d(l)+e(l)/(g+dsign(r,g))
	    s=.1d1
	    c=.1d1
	    p=.0d0
	    do i=m-1,l,-1
	      f=s*e(i)
	      b=c*e(i)
	      r=dpythag(f,g)
	      e(i+1)=r
	      if (r.eq..0d0)then
	        d(i+1)=d(i+1)-p
	        e(m)=.0d0
	        goto 1
	      end if
	      s=f/r
	      c=g/r
	      g=d(i+1)-p
	      r=(d(i)-g)*s+.2d1*c*b
	      p=s*r
	      d(i+1)=g+p
	      g=c*r-b
!     Omit lines from here ...
	      do k=1,n
	        f=z(k,i+1)
	        z(k,i+1)=s*z(k,i)+c*f
	        z(k,i)=c*z(k,i)-s*f
            end do
!     ... to here when finding only eigenvalues.
	    end do
	    d(l)=d(l)-p
	    e(l)=g
	    e(m)=.0d0
	    goto 1
	  end if
	end do

	return
	end
	
	subroutine tqli2(d,e,n,np)
!
!  Adapted to double precision from the Numerical Recipes
!  Hector: Removed calculation of z
	
	integer n,np
	integer i,iter,k,l,m

	double precision d(np),e(np)
	double precision b,c,dd,f,g,p,r,s,dpythag

	do i=2,n
	  e(i-1)=e(i)
	end do
	e(n)=.0d0
	do l=1,n
	  iter=0
1       do m=l,n-1
	    dd=dabs(d(m))+dabs(d(m+1))
	    if ((dabs(e(m))+dd).eq.dd) goto 2
	  end do
	  m=n
2       if (m.ne.l)then
	    if (iter.eq.30) pause 'too many iterations in tqli'
	    iter=iter+1
	    g=(d(l+1)-d(l))/(.2d1*e(l))
	    r=dpythag(g,.1d1)
	    g=d(m)-d(l)+e(l)/(g+dsign(r,g))
	    s=.1d1
	    c=.1d1
	    p=.0d0
	    do i=m-1,l,-1
	      f=s*e(i)
	      b=c*e(i)
	      r=dpythag(f,g)
	      e(i+1)=r
	      if (r.eq..0d0)then
	        d(i+1)=d(i+1)-p
	        e(m)=.0d0
	        goto 1
	      end if
	      s=f/r
	      c=g/r
	      g=d(i+1)-p
	      r=(d(i)-g)*s+.2d1*c*b
	      p=s*r
	      d(i+1)=g+p
	      g=c*r-b
	    end do
	    d(l)=d(l)-p
	    e(l)=g
	    e(m)=.0d0
	    goto 1
	  end if
	end do

	return
	end
