      SUBROUTINE CHIG(ID,FREQ,CHIOLD,CHIE,ETAOLD)
C
C FM is a fudge factor for bf metal opacity
C FH is a fudge factor for bf+ff H(-)  opacity
C
C IAC, 30.05.96 I use FM and FH from Jo Bruls thesis, p.20
C
C FH & FM are calculated in SCHIFAST
C
      PARAMETER (MDEP=1,MK=1,MFT=1)  
C            INCLUDE 'PARAMAX'
C                      
c Hector: I'm hardwiring the IFUDGE value 
      Parameter (IFUDGE=1)
      REAL*8 H2PKUR,AHMFF,GFREE,AHMBF,GAUNT,OPMET,SCATL
      REAL*8 SIGKK,SIGH,CONT,SM,GF,CFF,CNEG,CMET,STIM
      REAL*8 HKT,SRT,EX,BCO1,BCO,XX,EXF,B
      REAL NE,NATOM,NHYD,NP,M                                           
      DIMENSION NBELO1(2,25)                                  
      COMMON V(10300)                                                   
C
      COMMON/BION/ BM(MDEP,30)
C 
      COMMON/CKOEF/ DLOICH(MDEP),DLOATE(MDEP)
C                               
      COMMON/OPAC/ M(MDEP),RHO(MDEP),EIHC(MFT),GIS(MFT),QERF(MFT),          
     ,WT(MFT),PHOTO(MFT),NXTION(MK),BNU(MFT)
C                            
      COMMON/MODEL/ NE(MDEP),TEMP(MDEP),PE(MDEP),NATOM(MDEP)
C                    
      COMMON/POPUL/ HTOT(MDEP),NHYD(5,MDEP),NP(MDEP)
C 
c Hector: I comment out this line      COMMON/FUDGE/ IFUDGE
C                        
      EQUIVALENCE(V(2101),NBELO1(1))                    
      DATA NLH/5/  

        FH=1.0
        FM=1.0
          IF(IFUDGE.EQ.0) GO TO 1
C
C  Lambda W in A
C
          W=2.99792458E18/FREQ 
      
C-----------------------------------------------------
C Fudge factor for negative hydrogen - FH
C-----------------------------------------------------
      IF(W.LT.2080.) FH=1.
 
      IF(W.GE.2080. .AND. W.LT.2300.) THEN
       FH=7.5-(7.5-3.5)*(W-2080.)/(2300.-2080.)
      ENDIF 

      IF(W.GE.2300. .AND. W.LT.2500.) THEN
       FH=3.5-(3.5-2.5)*(W-2300.)/(2500.-2300.)
      ENDIF

      IF(W.GE.2500. .AND. W.LT.2650.) THEN
       FH=5.4-(5.4-5.)*(W-2500.)/(2650.-2500.)
      ENDIF

      IF(W.GE.2650. .AND. W.LT.3000.) THEN
       FH=2.5-(2.5-1.5)*(W-2650.)/(3000.-2650.)
      ENDIF

      IF(W.GE.3000. .AND. W.LT.4200.) THEN
       FH=1.5-(1.5-1.)*(W-3000.)/(4200.-3000.)
      ENDIF


      IF(W.GE.4200.) FH=1. 

C
C-----------------------------------------------------
C Fudge factor for BF metals  - FM
C----------------------------------------------------- 
      IF(W.LT.1536.) FM=1.

      IF(W.GE.1536. .AND. W.LT.1679.) FM=2.

      IF(W.GE.1679. .AND. W.LT.1850.) THEN
       FM=21.-(21.-11.)*(W-1679.)/(1850.-1679.)
      ENDIF

      IF(W.GE.1850. .AND. W.LT.1964.) THEN
        FM=2.2-(2.2-2.)*(W-1850.)/(1964.-1850.)
       ENDIF

      IF(W.GE.1964. .AND. W.LT.2080.) THEN
        FM=2.5-(2.5-2.)*(W-1964.)/(2080.-1964.)
      ENDIF

      IF(W.GE.2080.) FM=1.

C----------------------------------------------------    
C
C       print FM and FH
C
C          IF(ID.EQ.1) THEN
C          IF(W.GE.2100 .AND. W.LE.3000) WRITE(6,*) 'FH=',FH,W 
C          IF(W.GE.1400 .AND. W.LE.2100) WRITE(6,*) 'FM=',FM,W
C          ENDIF
                                               
    1      SM=0.0                                                            
      CONT=0.0                                                        
      HKT=157896./3.2901D15/TEMP(ID)                                   
      SRT=1.0/SQRT(TEMP(ID))                                           
      THETA=5040./TEMP(ID)                                            
      XX=HKT*FREQ
      EX=DEXP(XX)                                                       
      BCO1=1.474527D-2*(1.0D-15*FREQ)**3                               
      BCO=BCO1/(EX-1.0)                                                       
C*****OPACITY FOR NEGATIVE H(FF) AND MOLECULE H2+(TOTAL)  
C
C     FF(H-) Multiply by fuge factor FH
C ----------------------------------------
             
      CHIOLD=NHYD(1,ID)*(AHMFF(THETA,FREQ)*1.0E-26*PE(ID)*FH+             
     ,NP(ID)*H2PKUR(TEMP(ID),FREQ))/RHO(ID)                             
      CHFF=CHIOLD                                                      
C*****OPACITY FOR NEUTRAL H(FF)                                       
      FRQO=3.29E15/36.0                                                 
      FF=AMIN1(FRQO,FREQ)                                               
      SIGKK=3.6919D8/FREQ/FREQ**2                                      
      GF=GFREE(FREQ,TEMP(ID))                                          
      XX=HKT*FF
      EXF=DEXP(XX)                                                       
      EX=1.0/EX                                                         
      CFF=SIGKK*SRT*(GF-1.0+EXF)*NE(ID)*NP(ID)*(1.0-EX)/RHO(ID)       
      CHIOLD=CHIOLD+CFF                                                
C*****EMISSION FOR H-(FF),H2+,H0(FF)                                    
      ETAOLD=BCO*CHIOLD                                               
      SIGH=0.0                                                          
C*****OPACITY FOR NEUTRAL H(BF)                                       
      DO 13 IL=1,NLH                                                    
      FEDGE=3.29E15/FLOAT(IL*IL)                                        
      IF(FREQ.LT.FEDGE) GO TO 13                                      
      X=IL**5                                                          
      IF(IL.LE.NBELO1(2,1)) GO TO 51                                    
      B=1.0                                                            
      GO TO 551                                                        
   51 NN=NBELO1(1,1)+IL                                                 
      B=BM(ID,NN)                                                      
  551 SIGH=(2.815D29/FREQ**2)*GAUNT(IL,FREQ)/X/FREQ                    
      STIM=1.0-EX/B                                                     
      CONT=SIGH*NHYD(IL,ID)*STIM/RHO(ID)                               
      SM=CONT+SM                                                        
      CHIOLD=CHIOLD+CONT                                               
      ETAOLD=ETAOLD+SIGH*NHYD(IL,ID)*                                   
     ,BCO1*EX/B/RHO(ID)                                                 
   13 CONTINUE                                                        
      CONT=SM                                                           
C*****OPACITY FOR NEGATIVE H(BF) 
C
C     BF(H-) Multiply by fuge factor FH
C ----------------------------------------
                                      
      IF(NBELO1(1,1).EQ.0) GO TO 14                                   
      B=BM(ID,1)                                                        
      GO TO 15                                                          
   14 B=1.0                                                             
   15 STIM=(B-EX)*1.0D-26                                              
      CNEG=NHYD(1,ID)*PE(ID)*AHMBF(THETA,FREQ)*STIM*FH/RHO(ID)            
      CHIOLD=CHIOLD+CNEG                                               
      ETAOLD=ETAOLD+CNEG*BCO1*EX/(B-EX)                                
C*****OPACITY FOR METALS(SI,AL,MG,C,FE) 
C
C     BF(Metals) Multiply by fuge factor FM
C ----------------------------------------
                               
      CMET=HTOT(ID)*1.0D-18*FM*OPMET(ID,FREQ,.FALSE.)/RHO(ID)              
      CHIOLD=CHIOLD+CMET                                               
      ETAOLD=ETAOLD+HTOT(ID)*1.0D-18*EX*BCO1*FM*                         
     ,OPMET(ID,FREQ,.TRUE.)/RHO(ID)                                    
C*****SCATTERING ON ELECTRONS AND HI                                    
      CHIE=(6.65D-25*NE(ID)+SCATL(FREQ)*NHYD(1,ID))/RHO(ID)           
      DLOICH(ID)=CHIOLD+CHIE                                            
      DLOATE(ID)=ETAOLD                                                
      RETURN                                                           
      END                                                             
