! Initialization for the SOPA opacity package. This routine is only
! needed once per execution, in order to store some proper values in
! the SOPA common blocks.
!
Subroutine Init_sopas
  Use atomic_data
  Implicit none
  Logical, Save :: First_time=.TRUE.
  Logical :: exists
  Integer :: lun, Get_lun
!
  If (.not.First_time) Return
  First_time=.FALSE.
  lun=Get_lun()
  Inquire(File='ion.dat', exist=exists)
  If (.not.exists) then
     Inquire(File=Atomic_data_dir//'ion.dat', exist=exists)
     If (.not.exists) then
        Print *,'Cannot find the file ion.dat!! Aborting...'
        Stop
     End if
     Open(unit=lun, File=Atomic_data_dir//'ion.dat')
  else
     Open(unit=lun, File='ion.dat')
  End if
  Call readion(N_elements, Atom_char, At_abund, lun)
  Close (unit=lun)
  Return
!
End Subroutine Init_sopas
