! This subroutine constructs the absorption matrix at all the depth-points
! from the array of elements Phi_x and Psi_x. The matrix is normalized to
! the continuum opacity at 5000 Angstroms (which enters through the array
! Cont).
!
Subroutine Abs_matrix(npoints, nwlengths, Phi_I, Phi_Q, Phi_U, Phi_V, Psi_Q, &
             Psi_U, Psi_V, Cont, Absorp) ! Construct absorption matrix
  Implicit None
  Integer :: npoints, nwlengths, iwave
  Real, Dimension (4, 4, nwlengths, npoints) :: Absorp
  Real, Dimension (nwlengths, npoints) :: Phi_I, Phi_Q, Phi_U, Phi_V
  Real, Dimension (nwlengths, npoints) :: Psi_Q, Psi_U, Psi_V
  Real, Dimension (npoints) :: Cont
!
  Do iwave=1, nwlengths
     Phi_I(iwave, :)=Phi_I(iwave, :)/Cont(:)
     Phi_Q(iwave, :)=Phi_Q(iwave, :)/Cont(:)
     Phi_U(iwave, :)=Phi_U(iwave, :)/Cont(:)
     Phi_V(iwave, :)=Phi_V(iwave, :)/Cont(:)
     Psi_Q(iwave, :)=Psi_Q(iwave, :)/Cont(:)
     Psi_U(iwave, :)=Psi_U(iwave, :)/Cont(:)
     Psi_V(iwave, :)=Psi_V(iwave, :)/Cont(:)
  End do
!
  Absorp(1,1,1:nwlengths,1:npoints)=Phi_I(1:nwlengths,1:npoints)
  Absorp(2,2,1:nwlengths,1:npoints)=Phi_I(1:nwlengths,1:npoints)
  Absorp(3,3,1:nwlengths,1:npoints)=Phi_I(1:nwlengths,1:npoints)
  Absorp(4,4,1:nwlengths,1:npoints)=Phi_I(1:nwlengths,1:npoints)
!
  Absorp(1,2,1:nwlengths,1:npoints)=Phi_Q(1:nwlengths,1:npoints)
  Absorp(2,1,1:nwlengths,1:npoints)=Phi_Q(1:nwlengths,1:npoints)
!  
  Absorp(1,3,1:nwlengths,1:npoints)=Phi_U(1:nwlengths,1:npoints)
  Absorp(3,1,1:nwlengths,1:npoints)=Phi_U(1:nwlengths,1:npoints)
!  
  Absorp(1,4,1:nwlengths,1:npoints)=Phi_V(1:nwlengths,1:npoints)
  Absorp(4,1,1:nwlengths,1:npoints)=Phi_V(1:nwlengths,1:npoints)
!  
  Absorp(2,3,1:nwlengths,1:npoints)=Psi_V(1:nwlengths,1:npoints)
  Absorp(3,2,1:nwlengths,1:npoints)=-Psi_V(1:nwlengths,1:npoints)
!
  Absorp(2,4,1:nwlengths,1:npoints)=-Psi_U(1:nwlengths,1:npoints)
  Absorp(4,2,1:nwlengths,1:npoints)=Psi_U(1:nwlengths,1:npoints)
!
  Absorp(3,4,1:nwlengths,1:npoints)=Psi_Q(1:nwlengths,1:npoints)
  Absorp(4,3,1:nwlengths,1:npoints)=-Psi_Q(1:nwlengths,1:npoints)
!
  Return
End Subroutine Abs_matrix
