	real*8 function fun3j(j1,j2,j3,m1,m2,m3)
!
!   Calculates 3j value, each ji/mi is real
!
	implicit real*8 (f,j,m,s,t)

	parameter (idim0=1000)

	dimension sg(-idim0:idim0)
	dimension fl(0:idim0)

	common /sgnm/sg
	common /fact/fl

	ij1=idnint(j1+j1)
	ij2=idnint(j2+j2)
	ij3=idnint(j3+j3)
	im1=idnint(m1+m1)
	im2=idnint(m2+m2)
	im3=idnint(m3+m3)

	fun3j=.0d0

	if(ij1+ij2-ij3.lt.0) goto 1
	if(ij2+ij3-ij1.lt.0) goto 1
	if(ij3+ij1-ij2.lt.0) goto 1
	if(im1+im2+im3.ne.0) goto 1
	if(iabs(im1).gt.ij1) goto 1
	if(iabs(im2).gt.ij2) goto 1
	if(iabs(im3).gt.ij3) goto 1

	kmin=(ij3-ij1-im2)/2
	kmin1=kmin
	kmin2=(ij3-ij2+im1)/2

	if(kmin2.lt.kmin) kmin=kmin2
	kmin=-kmin
	if(kmin.lt.0) kmin=0

	kmax=idnint(j1+j2-j3)
	kmax1=kmax
	kmax2=idnint(j1-m1)
	kmax3=idnint(j2+m2)

	if(kmax2.lt.kmax) kmax=kmax2
	if(kmax3.lt.kmax) kmax=kmax3

	if(kmin.le.kmax) then

	  term=.0d0
	  term1=fn1(j1,j2,j3,m1,m2,m3)

	  sgn=sg((ij1-ij2-im3)/2)

	  do i=kmin,kmax
	    term2=fl(i)+fl(kmin1+i)+fl(kmin2+i) &
      	    +fl(kmax1-i)+fl(kmax2-i)+fl(kmax3-i)
	    term=sgn*sg(i)*dexp(term1-term2)
	    fun3j=fun3j+term
	  end do

	end if

1	end
