	subroutine MVOIGT2(nr,nwave,dlr,sr,a,v,hh,wc,dldop,etar,esar)
	
	Parameter (Piis=0.56418956659890107D0)
	Real*8 etar(nwave),esar(nwave)
!vetar,getar,ettar,ettvr,esar,vesar,gesar
!	Real*8 essar,essvr,ettmr,essmr
!	Real*8 da, dver, dH, dF, HV, FV, FA, HA
	REAL  DLR(nr),SR(nr)
        Real :: WC
        Real, Dimension(nwave) :: v, ver, H, F
        Integer :: nwave

! dlr es el desplazamiento en cm/gauss de la componete r Zeemann
! dlr es negativo luego debo cambiar de signo la exprsion
        etar=0.    !eta para luz circular derecha
        ESAR=0.    !perfil anomalo

        w1=wc/dldop
	      
!        If (nr .gt. 20) then 
!           print *,'Insufficient array size in mvoigt2.f'
!           stop
!        End if

        do ir=1,nr   !do en el numero de componentes r zeeman
           ver(1:nwave)=v(1:nwave)+dlr(ir)*HH
!	         H=VOIGT(a,ver,0)     !funcion de Voigt
!	         F=VOIGT(a,ver,1)     !funcion de Faraday
	      
           call voigt4(nwave,a,ver,H,F) ! Vector routine

!	         HV=-2.*ver*dH+4.*da*dF  !derivada con v de H
!	         FV=piis-da*dH-2.*dver*dF  !derivada con v de F
!                 FA=hv/2.             !derivada con a de F
!		 HA=-2.*fv    !derivada con a de H
           etar(:)=etar(:)+sr(ir)*H(:)
           esar(:)=esar(:)+sr(ir)*F(:)
!	         ettaR=ettaR+sr(ir)*HA
!	         essaR=essaR+sr(ir)*FA
!		 ettvR=ettvR-sr(ir)*HV*T13*dver
!		 essvR=ettvR-sr(ir)*FV*T13*dver
!	         ettmR=ettmR-sr(ir)*HV*t14*dver
!	         essmR=essmR-sr(ir)*FV*t14*dver

!		 vetar=vetar-sr(ir)*HV*w1
!		 vesar=vesar-sr(ir)*FV*w1
!		 getar=getar+sr(ir)*HV*dlr(ir)/dldop
!		 gesar=gesar+sr(ir)*FV*dlr(ir)/dldop
        End do         !fin del do en componentes r Zeeman

        ESAR=2.*ESAR
!	      VESAR=2.*VESAR
!	      GESAR=2.*GESAR
!	      ESSAR=2.*ESSAR
!	      ESSVR=2.*ESSVR
!	      essmr=2.*essmr

	return
      end subroutine MVOIGT2

      subroutine MVOIGT(nr,dlr,sr,a,v,hh,t13,t14,wc,dldop,etar,vetar, &
           getar,ettar,ettvr,esar,vesar,gesar,essar,essvr,ettmr,essmr)
	
	Parameter (Piis=0.56418956659890107D0)
	REAL WC
	Real*8 etar,vetar,getar,ettar,ettvr,esar,vesar,gesar
	Real*8 essar,essvr,ettmr,essmr
	Real*8 da, dver, dH, dF, HV, FV, FA, HA
	REAL DLR(nr),SR(nr)

! dlr es el desplazamiento en cm/gauss de la componete r Zeemann
! dlr es negativo luego debo cambiar de signo la exprsion
	      etar=0.    !eta para luz circular derecha
!	      vetar=0.   !parcial de eta con el campo de velocidad(s/cm)
!	      getar=0.   !parcial de eta con el campo magnetico.
!	      ETTAR=0.   !parcial de eta con a
!	      ETTVR=0.   !parcial de eta con v
!	      ettmr=0.   !parcial de eta con mic
	      ESAR=0.    !perfil anomalo
!	      VESAR=0.   !su derivada con la velocidad
!	      GESAR=0.   !su derivada con el campo
!	      ESSVR=0.   !parcial de esar con v
!	      ESSAR=0.   !parcial de esar con a
!	      essmr=0.   !parcial de esar con mic
	      
	      w1=wc/dldop
	      
!	      If (nr .gt. 20) then 
!		print *,'Insufficient array size in mvoigt.f'
!		stop
!	      End if

  	      do 102 ir=1,nr   !do en el numero de componentes r zeeman
  		 ver=v+dlr(ir)*HH
!	         H=VOIGT(a,ver,0)     !funcion de Voigt
!	         F=VOIGT(a,ver,1)     !funcion de Faraday
		 
		 da=a
		 dver=ver
	      
	         call voigt2(da,dver,dH,dF)

!	         HV=-2.*ver*dH+4.*da*dF  !derivada con v de H
!	         FV=piis-da*dH-2.*dver*dF  !derivada con v de F
!                 FA=hv/2.             !derivada con a de F
!		 HA=-2.*fv    !derivada con a de H
		 etar=etar+sr(ir)*dH
	         esar=esar+sr(ir)*dF
!	         ettaR=ettaR+sr(ir)*HA
!	         essaR=essaR+sr(ir)*FA
!		 ettvR=ettvR-sr(ir)*HV*T13*dver
!		 essvR=ettvR-sr(ir)*FV*T13*dver
!	         ettmR=ettmR-sr(ir)*HV*t14*dver
!	         essmR=essmR-sr(ir)*FV*t14*dver

!		 vetar=vetar-sr(ir)*HV*w1
!		 vesar=vesar-sr(ir)*FV*w1
!		 getar=getar+sr(ir)*HV*dlr(ir)/dldop
!		 gesar=gesar+sr(ir)*FV*dlr(ir)/dldop
102	      continue         !fin del do en componentes r Zeeman

	      ESAR=2.*ESAR
!	      VESAR=2.*VESAR
!	      GESAR=2.*GESAR
!	      ESSAR=2.*ESSAR
!	      ESSVR=2.*ESSVR
!	      essmr=2.*essmr


	return
	end

