!****************************************************
!
      FUNCTION PLANCK(U,T)

!
!  CALCULATES PLANCK FUNCTION BNY AT FREQUENCY U, TEMP T
!
      DATA EE/1.602189E-12/,HH/6.626176E-27/,CC/2.99792458E10/, &
       EM/9.109534E-28/,UU/1.6605655E-24/,BK/1.380662E-16/, &
       PI/3.14159265359/
!
      X=HH*U/BK/T
!      PRINT *,'BK=',BK
      
!      PRINT *,'T=',T
!      PRINT *,'U=',U
!      PRINT *,'X=',X
      
      IF(X.LT.80.) THEN
        PLANCK=2.0*HH*U/CC*U/CC*U/(EXP(X)-1.0)
      ELSE
        PLANCK=2.0*HH*U/CC*U/CC*U*EXP(-X)
      ENDIF
!
      RETURN
      END
!
!**********************************************************************
